class TasksController < ApplicationController
  before_filter :find_user, :except => :download

  # GET /tasks
  # GET /tasks.json
  def index
    @tasks = Task.all
    #@task1 = Task.new
    #@task1.number = 1
    #@task1.deadline = 2.weeks.ago
    #@task1.url = 'http://.../1'
    #@task1.id = 1
    #@task2 = Task.new
    #@task2.number = 2
    #@task2.deadline = Time.now
    #@task2.url = 'http://.../2'
    #@task2.id = 2
    #@tasks = [ @task1, @task2 ]

    respond_to do |format|
      format.html # index.html.erb
      format.json { render json: @tasks }
    end
  end

  # GET /tasks/1
  # GET /tasks/1.json
  def show
    @task = Task.find(params[:id])
    #@task = Task.new
    #@task.number = 1
    #@task.deadline = 2.weeks.ago
    #@task.url = 'http://.../1'
    #@task.id = 1
    
    if @user.student == 2
      @submission = Submission.find_by_user_id_and_task_id @user.id, @task.id
    elsif @user.student ==1
      #@submissions = Submission.find :all
      @submissions = Submission.get_solutions_page params[:page],@task.id
    end


    respond_to do |format|
      format.html # show.html.erb
      format.json { render json: @task }
    end
  end

  # GET /tasks/new
  # GET /tasks/new.json
  def new
    @task = Task.new

    respond_to do |format|
      format.html # new.html.erb
      format.json { render json: @task }
    end
  end

  # GET /tasks/1/edit
  def edit
    @task = Task.find(params[:id])
    #@task = Task.new
    #@task.number = 1
    #@task.deadline = 2.weeks.ago
    #@task.url = 'http://.../1'
    #@task.id = 1
  end

  # POST /tasks
  # POST /tasks.json
  def create
    @task = Task.new(params[:task])

    respond_to do |format|
      if @task.save
        format.html { redirect_to @task, notice: 'Task was successfully created.' }
        format.json { render json: @task, status: :created, location: @task }
      else
        format.html { render action: "new" }
        format.json { render json: @task.errors, status: :unprocessable_entity }
      end
    end
  end

  # PUT /tasks/1
  # PUT /tasks/1.json
  def update
    @task = Task.find(params[:id])

    respond_to do |format|
      if @task.update_attributes(params[:task])
        format.html { redirect_to @task, notice: 'Task was successfully updated.' }
        format.json { head :no_content }
      else
        format.html { render action: "edit" }
        format.json { render json: @task.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /tasks/1
  # DELETE /tasks/1.json
  def destroy
    @task = Task.find(params[:id])
    @task.destroy

    respond_to do |format|
      format.html { redirect_to tasks_url }
      format.json { head :no_content }
    end
  end
  
  def upload
    if session[:user]
      if !params[:upload].nil?
        Submission.save_file params[:uid], params[:id], params[:upload]
      else
        flash[:file] = "Empty file field"
      end
    else
      flash[:file] = "Please, log in to submit solution"
    end
    @task = Task.find params[:id]
    redirect_to "/tasks/#{@task.id}"
  end
  
  def download
    @user = User.find params[:uid]
    @task = Task.find params[:id]
    @submission = Submission.find_by_user_id_and_task_id(@user.id, @task.id, :order => 'created_at desc')
    #file = Rails.root.join("public", "data", "#{@user.neptun}_#{@task.number}.pdf")
    file = Rails.root.join("public","data", @submission.filename)
    #send_file file, :type=>'application/pdf', :disposition => :attachment
    send_file file, :type=>@submission.mime, :disposition => 'attachment'
  end
  
  private
  def find_user
    if session[:user]
      @user = User.find session[:user]
    end
  end
end
